#include <iostream>
#include <cstdlib>
#include <deque>

using namespace std;

long long seq[500200], min_seq = 9223372036854775807;
deque<pair<long long, long long> > si, ei;

int main() {
    bool last_s;
    long long n, x, y, last_e;
    cin>>n>>x>>y;
    for(long long i = 0; i < n; i++) {
        long long e;
        cin>>e;
        seq[i] = e;
        if(e == x || e == y) {
            if(si.size() == 0 || (last_s ? e == last_e : e != last_e)) {
                //cout<<"si push "<<i<<endl;
                si.push_back(make_pair(i, e));
                last_s = true;
            } else {
                for(long long j = ei.size(); j < si.size(); j++) {
                    //cout<<"ei push "<<i<<endl;
                    ei.push_back(make_pair(i, e));
                }
                last_s = false;
            }
            last_e = e;
        }
    }

    if(si.size() < ei.size())
        ei.pop_front();
    else if(si.size() > ei.size())
        si.pop_back();

    //cout<<"sz "<<si.size()<<" "<<ei.size()<<endl;

    long long os = si.size();
    for(long long i = 0; i < os; i++) {
        long long s = si.front().first, e = ei.front().first, dist = 0;
        //cout<<s<<" "<<e<<endl;
        si.pop_front();
        ei.pop_front();
        for(long long j = s; j < e; j++) {
            dist += abs(seq[j] - seq[j+1]);
        }
        if(dist < min_seq)
            min_seq = dist;
    }

    cout<<min_seq;

    cout<<endl;
}
