#include<iostream>

uint64_t bin_dec(uint64_t x)
{
    uint64_t st2=1, rez=0;

    while(x>0)
    {
        rez+=(st2*(x%10));
        x/=10;
        st2<<=1;
    }

    return rez;
}

uint64_t dec_bin(uint64_t x)
{
    uint64_t rez=0, st10=1;

    while(x>0)
    {
        rez+=(st10*(x%2));
        x>>=1;
        st10*=10;
    }

    return rez;
}

void plus1(uint64_t &x)
{
    uint64_t st10=1;

    while((x%(st10*10))/st10==1)
    {
        x-=st10;
        st10*=10;
    }

    x+=st10;
}

int main()
{

    uint64_t a, b, a1, b1, sum=0;
    std::cin >> a >> b;
    //plus1(a);
    //plus1(b);
    //std::cout << a << ' ' << b;

    a1=bin_dec(a);
    b1=bin_dec(b);

    for(; a<=b; plus1(a), a1++)
    {
        //std::cout << a << '\n';

        if(a%a1==0)
        {
            std::cout << a1 << '\n';
            sum++;
        }
    }

    if(sum==0)
    {
        std::cout << "-1\n";
    }

    return 0;
}
