#include<iostream>
#include<algorithm>
#include<math.h>
#include<string>
#include<queue>
#include<stack>

using namespace std;

string adder(string a)
{
    unsigned long long um = 1;
    for(int i = a.size() - 1;i >= 0;i--)
    {
        if(a[i] == '1')
        {
            a[i] = '0';
        }
        else
        {
            a[i] = '1';
            um = 0;
            break;
        }
    }
    if(um == 1)
    {
        a = '1' + a;
    }
    return a;
}

unsigned long long desNubr(string a)
{
    unsigned long long rez = 0,p = 1;
    for(int i = a.size() - 1;i >= 0;i--)
    {
        rez = rez + (a[i] - '0') * p;
        p *= 10;
    }
    return rez;
}

unsigned long long nubr(string a)
{
    unsigned long long rez = 0,p = 1;
    for(int i = a.size() - 1;i >= 0;i--)
    {
        rez = rez + (a[i] - '0') * p;
        p *= 2;
    }
    return rez;
}

int main()
{
    //1 100000000000000000000
    string now,fin;
    cin>>now>>fin;
    unsigned long long br = 0,n;

    while(true)
    {
        n = nubr(now);

        if(desNubr(now) % n == 0)
        {
            cout<<n<<endl;
            br++;
        }
        if(now == fin)
        {
            break;
        }
        now = adder(now);
    }

    if(br == 0)
    {
        cout<<-1<<endl;
    }

    return 0;
}
